/* $Id: adjint.cpp,v 1.1.1.1.2.1.2.1 2005/12/12 12:25:08 cvsroot Exp $ */

/* DGAP - General Analytical Positioning
 * Copyright (C) 2005 Dirk Stallmann
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "adjint.h"

namespace DEP
{

// write structure of normal matrix in PBM-format

void AdjInterface::write_matrix_struct(ostream& os,
const Matrix<double>& atpa) const
{
	int r, c;

	// PBM header
	os << "P1\n" << atpa.rows() << " " << atpa.cols() << "\n" << endl;

	// Use only the upper triangle because the lower triangle is used
	// to store the Cholesky factor.
	for (r = 0; r < atpa.rows(); r++)
		{
    	for(c = 0; c < atpa.cols(); c++)
			{
			// only the upper triangle is stored??
	    	//if (atpa(r,c) == 0.) os << "0 "; else os << "1 ";
			if (c < r)
	    		if (atpa(c,r) == 0.) os << "0 "; else os << "1 ";
			else
	    		if (atpa(r,c) == 0.) os << "0 "; else os << "1 ";
			}
		os << endl;
		}
}

} // namespace DEP
